t / test-lib.shon commit Merge branch 'js/remote-improvements' (ca8a36e)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6# if --tee was passed, write the output not only to the terminal, but
   7# additionally to the file test-results/$BASENAME.out, too.
   8case "$GIT_TEST_TEE_STARTED, $* " in
   9done,*)
  10        # do not redirect again
  11        ;;
  12*' --tee '*|*' --va'*)
  13        mkdir -p test-results
  14        BASE=test-results/$(basename "$0" .sh)
  15        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  16         echo $? > $BASE.exit) | tee $BASE.out
  17        test "$(cat $BASE.exit)" = 0
  18        exit
  19        ;;
  20esac
  21
  22# Keep the original TERM for say_color
  23ORIGINAL_TERM=$TERM
  24
  25# For repeatability, reset the environment to known value.
  26LANG=C
  27LC_ALL=C
  28PAGER=cat
  29TZ=UTC
  30TERM=dumb
  31export LANG LC_ALL PAGER TERM TZ
  32EDITOR=:
  33VISUAL=:
  34unset GIT_EDITOR
  35unset AUTHOR_DATE
  36unset AUTHOR_EMAIL
  37unset AUTHOR_NAME
  38unset COMMIT_AUTHOR_EMAIL
  39unset COMMIT_AUTHOR_NAME
  40unset EMAIL
  41unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  42unset GIT_AUTHOR_DATE
  43GIT_AUTHOR_EMAIL=author@example.com
  44GIT_AUTHOR_NAME='A U Thor'
  45unset GIT_COMMITTER_DATE
  46GIT_COMMITTER_EMAIL=committer@example.com
  47GIT_COMMITTER_NAME='C O Mitter'
  48unset GIT_DIFF_OPTS
  49unset GIT_DIR
  50unset GIT_WORK_TREE
  51unset GIT_EXTERNAL_DIFF
  52unset GIT_INDEX_FILE
  53unset GIT_OBJECT_DIRECTORY
  54unset GIT_CEILING_DIRECTORIES
  55unset SHA1_FILE_DIRECTORIES
  56unset SHA1_FILE_DIRECTORY
  57GIT_MERGE_VERBOSITY=5
  58export GIT_MERGE_VERBOSITY
  59export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  60export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  61export EDITOR VISUAL
  62GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
  63
  64# Protect ourselves from common misconfiguration to export
  65# CDPATH into the environment
  66unset CDPATH
  67
  68case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  69        1|2|true)
  70                echo "* warning: Some tests will not work if GIT_TRACE" \
  71                        "is set as to trace on STDERR ! *"
  72                echo "* warning: Please set GIT_TRACE to something" \
  73                        "other than 1, 2 or true ! *"
  74                ;;
  75esac
  76
  77# Each test should start with something like this, after copyright notices:
  78#
  79# test_description='Description of this test...
  80# This test checks if command xyzzy does the right thing...
  81# '
  82# . ./test-lib.sh
  83[ "x$ORIGINAL_TERM" != "xdumb" ] && (
  84                TERM=$ORIGINAL_TERM &&
  85                export TERM &&
  86                [ -t 1 ] &&
  87                tput bold >/dev/null 2>&1 &&
  88                tput setaf 1 >/dev/null 2>&1 &&
  89                tput sgr0 >/dev/null 2>&1
  90        ) &&
  91        color=t
  92
  93while test "$#" -ne 0
  94do
  95        case "$1" in
  96        -d|--d|--de|--deb|--debu|--debug)
  97                debug=t; shift ;;
  98        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
  99                immediate=t; shift ;;
 100        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 101                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 102        -h|--h|--he|--hel|--help)
 103                help=t; shift ;;
 104        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 105                verbose=t; shift ;;
 106        -q|--q|--qu|--qui|--quie|--quiet)
 107                quiet=t; shift ;;
 108        --no-color)
 109                color=; shift ;;
 110        --no-python)
 111                # noop now...
 112                shift ;;
 113        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 114                valgrind=t; verbose=t; shift ;;
 115        --tee)
 116                shift ;; # was handled already
 117        *)
 118                break ;;
 119        esac
 120done
 121
 122if test -n "$color"; then
 123        say_color () {
 124                (
 125                TERM=$ORIGINAL_TERM
 126                export TERM
 127                case "$1" in
 128                        error) tput bold; tput setaf 1;; # bold red
 129                        skip)  tput bold; tput setaf 2;; # bold green
 130                        pass)  tput setaf 2;;            # green
 131                        info)  tput setaf 3;;            # brown
 132                        *) test -n "$quiet" && return;;
 133                esac
 134                shift
 135                printf "* %s" "$*"
 136                tput sgr0
 137                echo
 138                )
 139        }
 140else
 141        say_color() {
 142                test -z "$1" && test -n "$quiet" && return
 143                shift
 144                echo "* $*"
 145        }
 146fi
 147
 148error () {
 149        say_color error "error: $*"
 150        trap - EXIT
 151        exit 1
 152}
 153
 154say () {
 155        say_color info "$*"
 156}
 157
 158test "${test_description}" != "" ||
 159error "Test script did not set test_description."
 160
 161if test "$help" = "t"
 162then
 163        echo "$test_description"
 164        exit 0
 165fi
 166
 167exec 5>&1
 168if test "$verbose" = "t"
 169then
 170        exec 4>&2 3>&1
 171else
 172        exec 4>/dev/null 3>/dev/null
 173fi
 174
 175test_failure=0
 176test_count=0
 177test_fixed=0
 178test_broken=0
 179test_success=0
 180
 181die () {
 182        echo >&5 "FATAL: Unexpected exit with code $?"
 183        exit 1
 184}
 185
 186trap 'die' EXIT
 187
 188# The semantics of the editor variables are that of invoking
 189# sh -c "$EDITOR \"$@\"" files ...
 190#
 191# If our trash directory contains shell metacharacters, they will be
 192# interpreted if we just set $EDITOR directly, so do a little dance with
 193# environment variables to work around this.
 194#
 195# In particular, quoting isn't enough, as the path may contain the same quote
 196# that we're using.
 197test_set_editor () {
 198        FAKE_EDITOR="$1"
 199        export FAKE_EDITOR
 200        VISUAL='"$FAKE_EDITOR"'
 201        export VISUAL
 202}
 203
 204test_tick () {
 205        if test -z "${test_tick+set}"
 206        then
 207                test_tick=1112911993
 208        else
 209                test_tick=$(($test_tick + 60))
 210        fi
 211        GIT_COMMITTER_DATE="$test_tick -0700"
 212        GIT_AUTHOR_DATE="$test_tick -0700"
 213        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 214}
 215
 216# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 217#
 218# This will commit a file with the given contents and the given commit
 219# message.  It will also add a tag with <message> as name.
 220#
 221# Both <file> and <contents> default to <message>.
 222
 223test_commit () {
 224        file=${2:-"$1.t"}
 225        echo "${3-$1}" > "$file" &&
 226        git add "$file" &&
 227        test_tick &&
 228        git commit -m "$1" &&
 229        git tag "$1"
 230}
 231
 232# Call test_merge with the arguments "<message> <commit>", where <commit>
 233# can be a tag pointing to the commit-to-merge.
 234
 235test_merge () {
 236        test_tick &&
 237        git merge -m "$1" "$2" &&
 238        git tag "$1"
 239}
 240
 241# You are not expected to call test_ok_ and test_failure_ directly, use
 242# the text_expect_* functions instead.
 243
 244test_ok_ () {
 245        test_count=$(expr "$test_count" + 1)
 246        test_success=$(expr "$test_success" + 1)
 247        say_color "" "  ok $test_count: $@"
 248}
 249
 250test_failure_ () {
 251        test_count=$(expr "$test_count" + 1)
 252        test_failure=$(expr "$test_failure" + 1);
 253        say_color error "FAIL $test_count: $1"
 254        shift
 255        echo "$@" | sed -e 's/^/        /'
 256        test "$immediate" = "" || { trap - EXIT; exit 1; }
 257}
 258
 259test_known_broken_ok_ () {
 260        test_count=$(expr "$test_count" + 1)
 261        test_fixed=$(($test_fixed+1))
 262        say_color "" "  FIXED $test_count: $@"
 263}
 264
 265test_known_broken_failure_ () {
 266        test_count=$(expr "$test_count" + 1)
 267        test_broken=$(($test_broken+1))
 268        say_color skip "  still broken $test_count: $@"
 269}
 270
 271test_debug () {
 272        test "$debug" = "" || eval "$1"
 273}
 274
 275test_run_ () {
 276        eval >&3 2>&4 "$1"
 277        eval_ret="$?"
 278        return 0
 279}
 280
 281test_skip () {
 282        this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
 283        this_test="$this_test.$(expr "$test_count" + 1)"
 284        to_skip=
 285        for skp in $GIT_SKIP_TESTS
 286        do
 287                case "$this_test" in
 288                $skp)
 289                        to_skip=t
 290                esac
 291        done
 292        case "$to_skip" in
 293        t)
 294                say_color skip >&3 "skipping test: $@"
 295                test_count=$(expr "$test_count" + 1)
 296                say_color skip "skip $test_count: $1"
 297                : true
 298                ;;
 299        *)
 300                false
 301                ;;
 302        esac
 303}
 304
 305test_expect_failure () {
 306        test "$#" = 2 ||
 307        error "bug in the test script: not 2 parameters to test-expect-failure"
 308        if ! test_skip "$@"
 309        then
 310                say >&3 "checking known breakage: $2"
 311                test_run_ "$2"
 312                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 313                then
 314                        test_known_broken_ok_ "$1"
 315                else
 316                    test_known_broken_failure_ "$1"
 317                fi
 318        fi
 319        echo >&3 ""
 320}
 321
 322test_expect_success () {
 323        test "$#" = 2 ||
 324        error "bug in the test script: not 2 parameters to test-expect-success"
 325        if ! test_skip "$@"
 326        then
 327                say >&3 "expecting success: $2"
 328                test_run_ "$2"
 329                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 330                then
 331                        test_ok_ "$1"
 332                else
 333                        test_failure_ "$@"
 334                fi
 335        fi
 336        echo >&3 ""
 337}
 338
 339test_expect_code () {
 340        test "$#" = 3 ||
 341        error "bug in the test script: not 3 parameters to test-expect-code"
 342        if ! test_skip "$@"
 343        then
 344                say >&3 "expecting exit code $1: $3"
 345                test_run_ "$3"
 346                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 347                then
 348                        test_ok_ "$2"
 349                else
 350                        test_failure_ "$@"
 351                fi
 352        fi
 353        echo >&3 ""
 354}
 355
 356# test_external runs external test scripts that provide continuous
 357# test output about their progress, and succeeds/fails on
 358# zero/non-zero exit code.  It outputs the test output on stdout even
 359# in non-verbose mode, and announces the external script with "* run
 360# <n>: ..." before running it.  When providing relative paths, keep in
 361# mind that all scripts run in "trash directory".
 362# Usage: test_external description command arguments...
 363# Example: test_external 'Perl API' perl ../path/to/test.pl
 364test_external () {
 365        test "$#" -eq 3 ||
 366        error >&5 "bug in the test script: not 3 parameters to test_external"
 367        descr="$1"
 368        shift
 369        if ! test_skip "$descr" "$@"
 370        then
 371                # Announce the script to reduce confusion about the
 372                # test output that follows.
 373                say_color "" " run $(expr "$test_count" + 1): $descr ($*)"
 374                # Run command; redirect its stderr to &4 as in
 375                # test_run_, but keep its stdout on our stdout even in
 376                # non-verbose mode.
 377                "$@" 2>&4
 378                if [ "$?" = 0 ]
 379                then
 380                        test_ok_ "$descr"
 381                else
 382                        test_failure_ "$descr" "$@"
 383                fi
 384        fi
 385}
 386
 387# Like test_external, but in addition tests that the command generated
 388# no output on stderr.
 389test_external_without_stderr () {
 390        # The temporary file has no (and must have no) security
 391        # implications.
 392        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 393        stderr="$tmp/git-external-stderr.$$.tmp"
 394        test_external "$@" 4> "$stderr"
 395        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 396        descr="no stderr: $1"
 397        shift
 398        say >&3 "expecting no stderr from previous command"
 399        if [ ! -s "$stderr" ]; then
 400                rm "$stderr"
 401                test_ok_ "$descr"
 402        else
 403                if [ "$verbose" = t ]; then
 404                        output=`echo; echo Stderr is:; cat "$stderr"`
 405                else
 406                        output=
 407                fi
 408                # rm first in case test_failure exits.
 409                rm "$stderr"
 410                test_failure_ "$descr" "$@" "$output"
 411        fi
 412}
 413
 414# This is not among top-level (test_expect_success | test_expect_failure)
 415# but is a prefix that can be used in the test script, like:
 416#
 417#       test_expect_success 'complain and die' '
 418#           do something &&
 419#           do something else &&
 420#           test_must_fail git checkout ../outerspace
 421#       '
 422#
 423# Writing this as "! git checkout ../outerspace" is wrong, because
 424# the failure could be due to a segv.  We want a controlled failure.
 425
 426test_must_fail () {
 427        "$@"
 428        test $? -gt 0 -a $? -le 129 -o $? -gt 192
 429}
 430
 431# test_cmp is a helper function to compare actual and expected output.
 432# You can use it like:
 433#
 434#       test_expect_success 'foo works' '
 435#               echo expected >expected &&
 436#               foo >actual &&
 437#               test_cmp expected actual
 438#       '
 439#
 440# This could be written as either "cmp" or "diff -u", but:
 441# - cmp's output is not nearly as easy to read as diff -u
 442# - not all diff versions understand "-u"
 443
 444test_cmp() {
 445        $GIT_TEST_CMP "$@"
 446}
 447
 448# Most tests can use the created repository, but some may need to create more.
 449# Usage: test_create_repo <directory>
 450test_create_repo () {
 451        test "$#" = 1 ||
 452        error "bug in the test script: not 1 parameter to test-create-repo"
 453        owd=`pwd`
 454        repo="$1"
 455        mkdir -p "$repo"
 456        cd "$repo" || error "Cannot setup test environment"
 457        "$GIT_EXEC_PATH/git" init "--template=$owd/../templates/blt/" >&3 2>&4 ||
 458        error "cannot run git init -- have you built things yet?"
 459        mv .git/hooks .git/hooks-disabled
 460        cd "$owd"
 461}
 462
 463test_done () {
 464        trap - EXIT
 465        test_results_dir="$TEST_DIRECTORY/test-results"
 466        mkdir -p "$test_results_dir"
 467        test_results_path="$test_results_dir/${0%.sh}-$$"
 468
 469        echo "total $test_count" >> $test_results_path
 470        echo "success $test_success" >> $test_results_path
 471        echo "fixed $test_fixed" >> $test_results_path
 472        echo "broken $test_broken" >> $test_results_path
 473        echo "failed $test_failure" >> $test_results_path
 474        echo "" >> $test_results_path
 475
 476        if test "$test_fixed" != 0
 477        then
 478                say_color pass "fixed $test_fixed known breakage(s)"
 479        fi
 480        if test "$test_broken" != 0
 481        then
 482                say_color error "still have $test_broken known breakage(s)"
 483                msg="remaining $(($test_count-$test_broken)) test(s)"
 484        else
 485                msg="$test_count test(s)"
 486        fi
 487        case "$test_failure" in
 488        0)
 489                # We could:
 490                # cd .. && rm -fr 'trash directory'
 491                # but that means we forbid any tests that use their own
 492                # subdirectory from calling test_done without coming back
 493                # to where they started from.
 494                # The Makefile provided will clean this test area so
 495                # we will leave things as they are.
 496
 497                say_color pass "passed all $msg"
 498
 499                test -d "$remove_trash" &&
 500                cd "$(dirname "$remove_trash")" &&
 501                rm -rf "$(basename "$remove_trash")"
 502
 503                exit 0 ;;
 504
 505        *)
 506                say_color error "failed $test_failure among $msg"
 507                exit 1 ;;
 508
 509        esac
 510}
 511
 512# Test the binaries we have just built.  The tests are kept in
 513# t/ subdirectory and are run in 'trash directory' subdirectory.
 514TEST_DIRECTORY=$(pwd)
 515if test -z "$valgrind"
 516then
 517        PATH=$TEST_DIRECTORY/..:$PATH
 518        GIT_EXEC_PATH=$TEST_DIRECTORY/..
 519else
 520        make_symlink () {
 521                test -h "$2" &&
 522                test "$1" = "$(readlink "$2")" || {
 523                        # be super paranoid
 524                        if mkdir "$2".lock
 525                        then
 526                                rm -f "$2" &&
 527                                ln -s "$1" "$2" &&
 528                                rm -r "$2".lock
 529                        else
 530                                while test -d "$2".lock
 531                                do
 532                                        say "Waiting for lock on $2."
 533                                        sleep 1
 534                                done
 535                        fi
 536                }
 537        }
 538
 539        make_valgrind_symlink () {
 540                # handle only executables
 541                test -x "$1" || return
 542
 543                base=$(basename "$1")
 544                symlink_target=$TEST_DIRECTORY/../$base
 545                # do not override scripts
 546                if test -x "$symlink_target" &&
 547                    test ! -d "$symlink_target" &&
 548                    test "#!" != "$(head -c 2 < "$symlink_target")"
 549                then
 550                        symlink_target=../valgrind.sh
 551                fi
 552                case "$base" in
 553                *.sh|*.perl)
 554                        symlink_target=../unprocessed-script
 555                esac
 556                # create the link, or replace it if it is out of date
 557                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 558        }
 559
 560        # override all git executables in TEST_DIRECTORY/..
 561        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 562        mkdir -p "$GIT_VALGRIND"/bin
 563        for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
 564        do
 565                make_valgrind_symlink $file
 566        done
 567        OLDIFS=$IFS
 568        IFS=:
 569        for path in $PATH
 570        do
 571                ls "$path"/git-* 2> /dev/null |
 572                while read file
 573                do
 574                        make_valgrind_symlink "$file"
 575                done
 576        done
 577        IFS=$OLDIFS
 578        PATH=$GIT_VALGRIND/bin:$PATH
 579        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 580        export GIT_VALGRIND
 581fi
 582GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 583unset GIT_CONFIG
 584GIT_CONFIG_NOSYSTEM=1
 585GIT_CONFIG_NOGLOBAL=1
 586export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 587
 588GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 589export GITPERLLIB
 590test -d ../templates/blt || {
 591        error "You haven't built things yet, have you?"
 592}
 593
 594if ! test -x ../test-chmtime; then
 595        echo >&2 'You need to build test-chmtime:'
 596        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 597        exit 1
 598fi
 599
 600. ../GIT-BUILD-OPTIONS
 601
 602# Test repository
 603test="trash directory.$(basename "$0" .sh)"
 604test ! -z "$debug" || remove_trash="$TEST_DIRECTORY/$test"
 605rm -fr "$test" || {
 606        trap - EXIT
 607        echo >&5 "FATAL: Cannot prepare test area"
 608        exit 1
 609}
 610
 611test_create_repo "$test"
 612# Use -P to resolve symlinks in our working directory so that the cwd
 613# in subprocesses like git equals our $PWD (for pathname comparisons).
 614cd -P "$test" || exit 1
 615
 616this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
 617for skp in $GIT_SKIP_TESTS
 618do
 619        to_skip=
 620        for skp in $GIT_SKIP_TESTS
 621        do
 622                case "$this_test" in
 623                $skp)
 624                        to_skip=t
 625                esac
 626        done
 627        case "$to_skip" in
 628        t)
 629                say_color skip >&3 "skipping test $this_test altogether"
 630                say_color skip "skip all tests in $this_test"
 631                test_done
 632        esac
 633done